      subroutine create_state_vector(nlat,nlon,nlev,ntime,field_in,vector_out)

      use floats
      implicit none
      

!INPUT VARIABLES
      integer*4                               :: nlat
      integer*4                               :: nlon
      integer*4                               :: nlev
      integer*4                               :: ntime
      real(std), dimension(nlon,nlat,nlev,ntime) :: field_in 
!OUTPUT VARIABLES
      real(std), dimension(nlat*nlon*nlev*ntime) :: vector_out

! local variables
      integer  :: ii,it,k,i,j,index

! create the state vector for CO and pressure:
! the values are put in the array with the nlon index changing fastest,
! then nlat,nlev, and ntime
      ii=0
      do it=1,ntime
       do k=1,nlev
        do j=1,nlat
         do i=1,nlon
          index=(it-1)*nlat*nlon*nlev+(k-1)*nlat*nlon+(j-1)*nlon+i
          vector_out(index)=field_in(i,j,k,it)
         end do
        end do
       end do
      end do

      return
      end
