MODULE MATRIX_CSR_STRUCTURE

USE floats 

IMPLICIT NONE

TYPE CSR_FORMAT
  integer*4                       :: NPRF
  integer*4                       :: ncol
  integer*4                       :: nrow
  integer*4                       :: nmax
  real(std),dimension(:,:),pointer  :: H
  integer*4,dimension(:,:),pointer  :: i
  integer*4,dimension(:,:),pointer  :: j
END TYPE CSR_FORMAT

END MODULE MATRIX_CSR_STRUCTURE  
!-------------------------------------------
MODULE MODEL_STRUCTURE
USE floats 
TYPE MODEL_DATA
  integer*4  :: nlon       !numb. of model longitudes
  integer*4  :: nlat       !numb. of model latitudes
  integer*4  :: nlev     !numb. of model veritcal levels

  real(std),dimension(2)                     :: date
  real(std), pointer                         :: lat(:,:)    
  real(std), pointer                         :: lon(:,:)    
  real(std), pointer                         :: traceur(:,:,:,:)      
  real(std), pointer                         :: pres(:,:,:,:) 
END TYPE MODEL_DATA
END MODULE MODEL_STRUCTURE

!-------------------------------------------


MODULE OBS_STRUCTURE
USE floats
TYPE OBSERV_DATA
  integer    :: n_prf      !number of observed profiles read
  real(std),pointer               :: lat(:)      !IASI lat
  real(std),pointer               :: lon(:)      !IASI lon
  real(std),pointer               :: date(:)     !IASI date
! pressure levels of observations (n_lvl,n_prf)
  real(std), pointer, dimension(:,:)     :: pres
  real(std), pointer, dimension(:,:)     :: traceur
  real(std), pointer, dimension(:)       :: traceur_column

END TYPE OBSERV_DATA
END MODULE OBS_STRUCTURE
