#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "fortint.h"

char* findLocalDefinitionFile(fortint);

int fileExists(char* fileName) {
struct stat buf;
int status;

  status = stat(fileName,&buf);
  if( (status == 0) && S_ISREG(buf.st_mode) ) return 1;

  return 0;
}

char* findLocalDefinitionFile(fortint definitionNumber) {
char * directoryPath;
char * directoryName;
static char fullFileName[256];
char fileName[] = "localDefinitionTemplate_ccc_nnn";
char defaultDirectory[] = "/home/ma/emos/tables";
char * endString;
char * startString;
fortint n;
int centre = definitionNumber/1000;
int number = definitionNumber%1000;
int defaultDirectoryChosen = 0;

  sprintf((fileName+24),"%03d",centre);
  sprintf((fileName+27),"_%03d",number);

  directoryPath = (char*) getenv("LOCAL_DEFINITION_TEMPLATES");
  if( directoryPath == NULL ) {
    defaultDirectoryChosen = 1;
    directoryPath = defaultDirectory;
  }
/*
// The directoryPath can have a list of directories separted by ':'.
// Check each possible directory to find a suitable file.
*/

  startString = directoryPath;

  while( (endString = strchr(startString,':')) != NULL ) {
    n = (int) (endString - startString);

    strncpy(fullFileName,startString,n);
    fullFileName[n] = '/';
    strcpy(&fullFileName[n+1],fileName);

    if( fileExists(fullFileName) ) return fullFileName;
    startString += (n+1);
  }
  if( startString != directoryPath )
    n = strlen(directoryPath) - (int) (startString - directoryPath);
  else
    n = strlen(directoryPath);

  strncpy(fullFileName,startString,n);
  fullFileName[n] = '/';
  strcpy(&fullFileName[n+1],fileName);

  if( fileExists(fullFileName) )
    return fullFileName;
  else {
    if( ! defaultDirectoryChosen ) {
      directoryPath = defaultDirectory;
      n = strlen(directoryPath);
      strncpy(fullFileName,directoryPath,n);
      fullFileName[n] = '/';
      strcpy(&fullFileName[n+1],fileName);
      if( fileExists(fullFileName) ) return fullFileName;
    }
    return NULL;
  }
}
