      SUBROUTINE LOADEV(EV,N,J,NRITZ,RITZ,BND,RITZV,IERR)
C
C     .... Subroutine to load the accepted Ritz values, their associated
C   .... error bounds and Ritz vectors back into memory from FORTRAN I/O
C     .... channel EV.
C
C     .... Input parameters
C
C .... EV    FORTRAN channel containing the accepted Ritz values/vectors
C     .... N     dimension of the eigenproblem
C     .... J     number of Lanczos steps actually taken
C
C     .... Output parameters:
C
C     .... NRITZ number of accepted Ritz values/vectors
C     .... RITZ  accepted Ritz values
C     .... BND   associated (refined) error bounds
C     .... RITZV accepted Ritz vectors, NRITZ of them
C     .... IERR  error condition as reported by READ
C
C     .. Scalar Arguments ..
      INTEGER           EV, IERR, J, N, NRITZ
C     .. Array Arguments ..
      REAL BND(J), RITZ(J), RITZV(N,J)
C     .. Local Scalars ..
      INTEGER           I, K
C     .. Executable Statements ..
C
      NRITZ = 0
CMH      OPEN (EV,FORM='UNFORMATTED')
      REWIND (EV)
      READ (EV) N, J, KAPPA
      DO 20 K = 1, J
         READ (EV,IOSTAT=IERR,ERR=60,END=40) RITZ(K), BND(K),
     *     (RITZV(I,K),I=1,N)
   20 CONTINUE
   40 IERR = 0
      NRITZ = K - 1
   60 CONTINUE
      RETURN
      END
