MODULE MPL_ABORT_MOD

USE MPL_DATA_MODULE
USE MPL_MPIF

USE PARKIND1  ,ONLY : JPIM     ,JPRB

PUBLIC MPL_ABORT

CONTAINS 

SUBROUTINE MPL_ABORT(CDMESSAGE)

IMPLICIT NONE

CHARACTER*(*),INTENT(IN),OPTIONAL :: CDMESSAGE
INTEGER(KIND=JPIM) :: IRETURN_CODE,IERROR

CLOSE(MPL_UNIT)
IF(PRESENT(CDMESSAGE)) THEN
  WRITE(MPL_ERRUNIT,'(2A)') 'MPL_ABORT:',CDMESSAGE
ENDIF
WRITE(MPL_ERRUNIT,'(A,I6)') 'MPL_ABORT CALLED FROM PROCESSOR ',MPL_RANK
#ifdef VPP
CALL ERRTRA
CALL SLEEP(30)
CALL VPP_ABORT()
#elif RS6K
CALL XL__TRBK
CALL FLUSH(0)
IRETURN_CODE=1
CALL MPI_ABORT(MPL_COMM,IRETURN_CODE,IERROR)
#else
CALL ABORT
STOP 'MPL_ABORT'
#endif

END SUBROUTINE MPL_ABORT

END MODULE MPL_ABORT_MOD
