      SUBROUTINE SGEMMX(NRP,NCP,M,
     & ONE,SA,IAC,IAR,SB,IBC,IBR,
     & ZER,SC,ICC,ICR)
!
!  Fortran subroutine equivalent to SGEMMX using SSLII dvmggm routine
!
!   C=A*B  , with arbitrary increments IAC,IAR, IBC,IBR, ICC,ICR
!
!  It will only work if ONE=1.0 and ZER=0.0
!
      REAL SA(*),SB(*),SC(*)
!     REAL A(NRP,m),B(m,NCP),C(NRP,NCP)
!
!   For maximum performance in dvmggm columns of matrices must
!   always start on a 64 byte boundary.
!
      real,allocatable :: a(:)

      integer apadlen,bpadlen,cpadlen
      integer aoffset,boffset,coffset
      integer offset
!
!   Check if ONE and ZERO have valid values, else ABORT
!
      IF (ONE.NE.1.0D0.OR.ZER.NE.0.0D0) then
           write(0,*) ' INVALID ARGUMENTS IN SGEMMX CALL'
           stop
      ENDIF
!

      if(ncp.eq.0) return

      nsize = 8 + (nrp+8)*m + (m+8)*ncp + (nrp+8)*ncp

      allocate(a(nsize))

      aoffset = mod(loc(a),64)/8
      apadlen = ((nrp+8)/8)*8


      boffset= aoffset + apadlen*m
      bpadlen = ((m+8)/8)*8

      coffset = boffset + bpadlen*ncp
      cpadlen = apadlen


!
      do j=1,m
        offset = aoffset + (j-1)*apadlen
!OCL  NOVREC
        do i=1,nrp
          a(offset + i)=SA(1+(I-1)*IAC+(J-1)*IAR)
        enddo
      enddo
!
      do k=1,ncp
        offset = boffset + (k-1)*bpadlen
!OCL  NOVREC
        do j=1,m
          a(offset + j)=SB(1+(J-1)*IBC+(K-1)*IBR)
        enddo
      enddo

      call dvmggm(a(aoffset+1),apadlen,a(boffset+1),bpadlen,
     &            a(coffset+1),cpadlen,nrp,m,ncp,icon)
      if(icon.ne.0) stop 'icon error at dvmggm SGEMMX.f'


      do k=1,ncp
        offset = coffset + (k-1)*cpadlen
!OCL  NOVREC
        do i=1,nrp
          SC(1+(I-1)*ICC+(K-1)*ICR)=a(offset +i)
        enddo
      enddo

      deallocate(a)

      RETURN
      END
