SUBROUTINE MXMAOP(PA,KA,KAD,PB,KB,KBD,PC,KC,KCA,KAR,KAC,KBC)

!**** *MXMAOP - Optimize call to SGEMMX

!     Purpose.
!     --------
!        Make sure SGEMMX is called in a way to insure maximum optimization.

!**   Interface.
!     ----------
!        CALL MXMAOP(PA,KA,KAD,PB,KB,KBD,PC,KC,KCA,KAR,KAC,KBC)

!        Explicit arguments : See SGEMMX documentaion.
!        --------------------

!        Implicit arguments :
!        --------------------

!     Method.
!     -------

!     Externals.   SGEMMX in Cray library.
!     ----------

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        Mats Hamrud and Philippe Courtier  *ECMWF*

!     Modifications.
!     --------------
!        Original : 88-01-28
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE


!     DUMMY INTEGER SCALARS
INTEGER(KIND=JPIM) :: KA
INTEGER(KIND=JPIM) :: KAC
INTEGER(KIND=JPIM) :: KAD
INTEGER(KIND=JPIM) :: KAR
INTEGER(KIND=JPIM) :: KB
INTEGER(KIND=JPIM) :: KBC
INTEGER(KIND=JPIM) :: KBD
INTEGER(KIND=JPIM) :: KC
INTEGER(KIND=JPIM) :: KCA


REAL(KIND=JPRB) :: PA(1),PB(1),PC(2)

!     ------------------------------------------------------------------

!*       1.       PERFORM LEGENDRE TRANFORM.
!                 --------------------------
IF (KAR >= KBC) THEN
  CALL SGEMMX(KAR,KBC,KAC,1.0_JPRB,PA,KA,KAD,PB,KB,KBD,0.0_JPRB,PC,KC,KCA)
ELSE
  CALL SGEMMX(KBC,KAR,KAC,1.0_JPRB,PB,KBD,KB,PA,KAD,KA,0.0_JPRB,PC,KCA,KC)
ENDIF

!     ------------------------------------------------------------------

RETURN
END SUBROUTINE MXMAOP



