#if defined(BLAS)
!OCL  NOUNROLL,NOPREEX,NOEVAL
      SUBROUTINE SGEMMX(NRP,NCP,M,
     &                  ONE,SA,IAC,IAR,SB,IBC,IBR,
     &                  ZER,SC,ICC,ICR)
C
C  Fortran subroutine equivalent to SGEMMX using SSLII dvmggm routine
C
C   C=A*B  , with arbitrary increments IAC,IAR, IBC,IBR, ICC,ICR
C
C  It will only work if ONE=1.0 and ZER=0.0
C
      REAL SA(*),SB(*),SC(*)
      REAL A(NRP,m),B(m,NCP),C(NRP,NCP)
C
C   Check if ONE and ZERO have valid values, else ABORT
C
      IF (ONE.NE.1.0D0.OR.ZER.NE.0.0D0)
     &     CALL ABOR1(' UNVALID ARGUMENTS IN SGEMMX CALL')
c
      if(ncp.eq.0) return
c
      do 1000 j=1,m
!OCL  NOVREC
      do 1000 i=1,nrp
        a(i,j)=SA(1+(I-1)*IAC+(J-1)*IAR)
1000  continue
c
      do 1100 k=1,ncp
!OCL  NOVREC
      do 1100 j=1,m
        b(j,k)=SB(1+(J-1)*IBC+(K-1)*IBR)
1100  continue
  
      CALL DGEMM('N','N',NRP,NCP,M,ONE,A,NRP,B,M,ZER,C,NRP)

      do 1200 k=1,ncp
!OCL  NOVREC
      do 1200 i=1,nrp
        SC(1+(I-1)*ICC+(K-1)*ICR)=c(i,k)
1200  continue
      RETURN
      END
#elif defined(RS6K)
      SUBROUTINE SGEMMX(NRP,NCP,M,
     &                  ONE,SA,IAC,IAR,SB,IBC,IBR,
     &                  ZER,SC,ICC,ICR)
C
C  Fortran subroutine equivalent to SGEMMX using DGEMUL essl routine
C
C   C=A*B  , with arbitrary increments IAC,IAR, IBC,IBR, ICC,ICR
C
C  It will only work if ONE=1.0 and ZER=0.0
C
      REAL SA(*),SB(*),SC(*)
C     REAL A(NRP,m),B(m,NCP),C(NRP,NCP)
      REAL A(NRP*m),B(m*NCP),C(NRP*NCP)
      INTEGER(KIND=8):: PA,PB,PC
C
C   Check if ONE and ZERO have valid values, else ABORT
C
      PA=LOC(A)
      PB=LOC(B)
      PC=LOC(C)
      IF(IAC.EQ.1 .AND. IAR.EQ.NRP) PA=LOC(SA)
      IF(IBC.EQ.1 .AND. IBR.EQ.M  ) PB=LOC(SB)
      IF(ICC.EQ.1 .AND. ICR.EQ.NRP) PC=LOC(SC)

!     write(0,*) "SGEMMX: NRP,NCP,M,IAC,IAR,IBC,IBR,ICC,ICR=",
!    &              NRP,NCP,M,IAC,IAR,IBC,IBR,ICC,ICR

      IF (ONE.NE.1.0D0.OR.ZER.NE.0.0D0)
     &     CALL ABOR1(' UNVALID ARGUMENTS IN SGEMMX CALL')
C
      if(ncp.eq.0) return
C
      if(pa.eq.loc(a)) then
        if(iar.gt.iac) then
          do j=1,m
            do i=1,nrp
              a(i+(j-1)*nrp)=SA(1+(I-1)*IAC+(J-1)*IAR)
            enddo
          enddo
        else
          do i=1,nrp
            do j=1,m
              a(j+(i-1)*m)=SA(1+(I-1)*IAC+(J-1)*IAR)
            enddo
          enddo
        endif
      endif
C
      if(pb.eq.loc(b)) then
        if(ibr.gt.ibc) then
          do k=1,ncp
            do j=1,m
              b(j+(k-1)*m)=SB(1+(J-1)*IBC+(K-1)*IBR)
            enddo
          enddo
        else
          do j=1,m
            do k=1,ncp
              b(k+(j-1)*ncp)=SB(1+(J-1)*IBC+(K-1)*IBR)
            enddo
          enddo
        endif
      endif

C     CALL DGEMM('N','N',NRP,NCP,M,ONE,A,NRP,B,M,ZER,C,NRP)

      if(icr.gt.icc) then
        if(ibr.gt.ibc) then
          if(iar.gt.iac) then
            CALL DGEMUL(%VAL(PA),NRP,'N',
     &                  %VAL(PB),M,'N',%VAL(PC),NRP,NRP,M,NCP)
          else
            CALL DGEMUL(%VAL(PA),M,'T',
     &                  %VAL(PB),M,'N',%VAL(PC),NRP,NRP,M,NCP)
          endif
        else
          if(iar.gt.iac) then
            CALL DGEMUL(%VAL(PA),NRP,'N',
     &                  %VAL(PB),NCP,'T',%VAL(PC),NRP,NRP,M,NCP)
          else
            CALL DGEMUL(%VAL(PA),M,'T',
     &                  %VAL(PB),NCP,'T',%VAL(PC),NRP,NRP,M,NCP)
          endif
        endif
      else
        if(ibr.gt.ibc) then
          if(iar.gt.iac) then
            CALL DGEMUL(%VAL(PB),M,'T',
     &                  %VAL(PA),NRP,'T',%VAL(PC),NCP,NCP,M,NRP)
          else
            CALL DGEMUL(%VAL(PB),M,'T',
     &                  %VAL(PA),M,'N',%VAL(PC),NCP,NCP,M,NRP)
          endif
        else
          if(iar.gt.iac) then
            CALL DGEMUL(%VAL(PB),NCP,'N',
     &                  %VAL(PA),NRP,'T',%VAL(PC),NCP,NCP,M,NRP)
          else
            CALL DGEMUL(%VAL(PB),NCP,'N',
     &                  %VAL(PA),M,'N',%VAL(PC),NCP,NCP,M,NRP)
          endif
        endif
      endif

      if(pc.eq.loc(c)) then
        if(icr.gt.icc) then
          do k=1,ncp
            do i=1,nrp
              SC(1+(I-1)*ICC+(K-1)*ICR)=c(i+nrp*(k-1))
            enddo
          enddo
        else
          do i=1,nrp
            do k=1,ncp
              SC(1+(I-1)*ICC+(K-1)*ICR)=c(k+ncp*(i-1))
            enddo
          enddo
        endif
      endif

      RETURN
      END
#elif defined(VPP)
      SUBROUTINE SGEMMX(NRP,NCP,M,
     & ONE,SA,IAC,IAR,SB,IBC,IBR,
     & ZER,SC,ICC,ICR)
!
!  Fortran subroutine equivalent to SGEMMX using SSLII dvmggm routine
!
!   C=A*B  , with arbitrary increments IAC,IAR, IBC,IBR, ICC,ICR
!
!  It will only work if ONE=1.0 and ZER=0.0
!
      REAL SA(*),SB(*),SC(*)
!     REAL A(NRP,m),B(m,NCP),C(NRP,NCP)
!
!   For maximum performance in dvmggm columns of matrices must
!   always start on a 64 byte boundary.
!
      real,allocatable :: a(:)

      integer apadlen,bpadlen,cpadlen
      integer aoffset,boffset,coffset
      integer offset
!
!   Check if ONE and ZERO have valid values, else ABORT
!
      IF (ONE.NE.1.0D0.OR.ZER.NE.0.0D0) then
           write(0,*) ' INVALID ARGUMENTS IN SGEMMX CALL'
           stop
      ENDIF
!

      if(ncp.eq.0) return

      nsize = 8 + (nrp+8)*m + (m+8)*ncp + (nrp+8)*ncp

      allocate(a(nsize))

      aoffset = mod(loc(a),64)/8
      apadlen = ((nrp+8)/8)*8


      boffset= aoffset + apadlen*m
      bpadlen = ((m+8)/8)*8

      coffset = boffset + bpadlen*ncp
      cpadlen = apadlen


!
      if(icc.eq.1)then

      do j=1,m
        offset = aoffset + (j-1)*apadlen
!OCL  NOVREC
        do i=1,nrp
          a(offset + i)=SA(1+(I-1)*IAC+(J-1)*IAR)
        enddo
      enddo
!
      do k=1,ncp
        offset = boffset + (k-1)*bpadlen
!OCL  NOVREC
        do j=1,m
          a(offset + j)=SB(1+(J-1)*IBC+(K-1)*IBR)
        enddo
      enddo

      call dvmggm(a(aoffset+1),apadlen,a(boffset+1),bpadlen,
     &            sc,icr,nrp,m,ncp,icon)
      if(icon.ne.0) stop 'icon error at dvmggm SGEMMX.f'


      else if(iac.eq.1)then

!
      do k=1,ncp
        offset = boffset + (k-1)*bpadlen
!OCL  NOVREC
        do j=1,m
          a(offset + j)=SB(1+(J-1)*IBC+(K-1)*IBR)
        enddo
      enddo

      call dvmggm(sa,iar,a(boffset+1),bpadlen,
     &            a(coffset+1),cpadlen,nrp,m,ncp,icon)
      if(icon.ne.0) stop 'icon error at dvmggm SGEMMX.f'


      do k=1,ncp
        offset = coffset + (k-1)*cpadlen
!OCL  NOVREC
        do i=1,nrp
          SC(1+(I-1)*ICC+(K-1)*ICR)=a(offset +i)
        enddo
      enddo

      else

      do j=1,m
        offset = aoffset + (j-1)*apadlen
!OCL  NOVREC
        do i=1,nrp
          a(offset + i)=SA(1+(I-1)*IAC+(J-1)*IAR)
        enddo
      enddo
!
      do k=1,ncp
        offset = boffset + (k-1)*bpadlen
!OCL  NOVREC
        do j=1,m
          a(offset + j)=SB(1+(J-1)*IBC+(K-1)*IBR)
        enddo
      enddo

      call dvmggm(a(aoffset+1),apadlen,a(boffset+1),bpadlen,
     &            a(coffset+1),cpadlen,nrp,m,ncp,icon)
      if(icon.ne.0) stop 'icon error at dvmggm SGEMMX.f'


      do k=1,ncp
        offset = coffset + (k-1)*cpadlen
!OCL  NOVREC
        do i=1,nrp
          SC(1+(I-1)*ICC+(K-1)*ICR)=a(offset +i)
        enddo
      enddo

      endif

      deallocate(a)

      RETURN
      END
#else
      SUBROUTINE SGEMMX(NRP,NCP,M,
     &                  ONE,SA,IAC,IAR,SB,IBC,IBR,
     &                  ZER,SC,ICC,ICR)
C
C  Fortran subroutine equivalent to SGEMMX, made from CRAY MXMA(3SCI)
C  See page 170 in CRAY Res. SR-2081 5.0
C
C   C=A*B  , with arbitrary increments IAC,IAR, IBC,IBR, ICC,ICR
C
C  It will only work if ONE=1.0 and ZER=0.0
C
      IMPLICIT LOGICAL (L)
      REAL SA(*),SB(*),SC(*)
C
C   Check if ONE and ZERO have valid values, else ABORT
C
      IF((ONE.NE.1.0.OR.ZER.NE.0.0).and.(ONE.NE.1.0D0.OR.ZER.NE.0.0D0))
     &     CALL ABOR1(' UNVALID ARGUMENTS IN SGEMMX CALL')
C  Initialize product
      DO 120 K=1,NCP
       DO 110 I=1,NRP
        SC(1+(I-1)*ICC+(K-1)*ICR) = 0.
C       (C(I,K) := 0.)
110    CONTINUE
120   CONTINUE
C  Multiply matrices from SA and SB
      DO 230 K=1,NCP
       DO 220 J=1,M
        DO 210 I=1,NRP
         SC(1+(I-1)*ICC+(K-1)*ICR)
     &     =SC(1+(I-1)*ICC+(K-1)*ICR)
     &      +SA(1+(I-1)*IAC+(J-1)*IAR)
     &       *SB(1+(J-1)*IBC+(K-1)*IBR)
C        (C(I,K):=C(I,K)+A(I,J)*B(J,K))
210     CONTINUE
220    CONTINUE
230   CONTINUE
      RETURN
      END
#endif
